#version 420 core
precision mediump float;
layout (location = 0) in vec3 i_position;
layout (location = 1) in vec3 i_colour;
out vec3 line_colour;

struct PointLight
{
	vec4 colour_brightness;
	vec4 position;
};

layout (std140, binding = 0) uniform Matrices
{
	mat4 view_matrix;
	mat4 proj_matrix;
	mat4 model_matrix;
	mat4 mvp_matrix;
	vec4 colour;
	vec4 tex_atlas_mul_xy;
	vec4 fog_colour_distance;
	ivec4 receivesshadows_unlit;
	ivec4 n_lights_by_type;
	PointLight point_lights[64];
};

void main()
{
	gl_Position = proj_matrix * view_matrix * vec4(i_position, 1.0f);
	line_colour = i_colour;
}