#version 420 core
in vec4 frag_pos;

uniform vec3 light_pos;

struct PointLight
{
	vec4 colour_brightness;
	vec4 position_cubemapindex;
};

layout (std140, binding = 0) uniform mesh_matrices
{
	mat4 view_matrix;
	mat4 proj_matrix;
	mat4 model_matrix;
	mat4 mvp_matrix;
	vec4 colour_;
	vec4 tex_atlas_mul_xy;
	vec4 fog_colour_distance;
	ivec4 receivesshadows_unlit;
	ivec4 n_lights_by_type;
	PointLight point_lights[64];
};

layout (std140, binding = 1) uniform light_matrices
{
	mat4 light_view_matrices[6];
	vec4 light_pos_far_plane;
	ivec4 currlightindex;
};

void main()
{
    // get distance between fragment and light source
    float light_distance = length(frag_pos.xyz - light_pos_far_plane.xyz);
    
    // map to [0;1] range by dividing by far_plane
    light_distance = light_distance / light_pos_far_plane.w;
    
    // write this as modified depth
    gl_FragDepth = light_distance;
}  