#version 420 core
layout (triangles) in;
layout (triangle_strip, max_vertices=18) out;

struct PointLight
{
	vec4 colour_brightness;
	vec4 position_cubemapindex;
};

layout (std140, binding = 0) uniform mesh_matrices
{
	mat4 view_matrix;
	mat4 proj_matrix;
	mat4 model_matrix;
	mat4 mvp_matrix;
	vec4 colour_;
	vec4 tex_atlas_mul_xy;
	vec4 fog_colour_distance;
	ivec4 receivesshadows_unlit;
	ivec4 n_lights_by_type;
	PointLight point_lights[64];
};

layout (std140, binding = 1) uniform light_matrices
{
	mat4 light_view_matrices[6];
	vec4 light_pos_far_plane;
	ivec4 currlightindex;
};

out vec4 frag_pos; // FragPos from GS (output per emitvertex)

void main()
{
    for(int face = 0; face < 6; ++face)
    {
        gl_Layer = face + 6 * int(point_lights[currlightindex.x].position_cubemapindex.w); // built-in variable that specifies to which face we render.
        for(int i = 0; i < 3; ++i) // for each triangle vertex
        {
            frag_pos = gl_in[i].gl_Position;
            gl_Position = light_view_matrices[face] * frag_pos;
            EmitVertex();
        }    
        EndPrimitive();
    }
}